2.3 Synths wechseln

# Synths wechseln

Bisher hatten wir viel Spaß damit Pieptöne zu erzeugen. Aber wahrscheinlich langweilt es dich langsam, immer wieder denselben Klang zu hören. Ist das alles, was Sonic Pi zu bieten hat? Live-Coding kann doch sicher mehr als nur einen einfachen Piepton zu spielen? Aber klar doch! In diesem Abschnitt schauen wir uns die aufregende Vielfalt der Klänge, die uns Sonic Pi bietet, an.

## Synths

Sonic Pi bringt eine Palette an Instrumenten mit, die Synths heißen, eine Kurzform für Synthesizer (Klangerzeuger). Samples sind vorher aufgenommene Klänge; demgegenüber erzeugen Synths neue Klänge, je nachdem, wie Du sie anlegst (wie das geht, werden wir später sehen). Die Synths von Sonic Pi sind sehr wirkungsvoll und ausdrucksstark und man kann damit tolle Sachen machen. Als erstes lernen wir, wie man einen Synth auswählt, den man benutzen möchte.

## Brilliante Sägen und Prophets

Einen spaßigen Sound ergibt die *Sägezahn-Welle* - probieren wir es mal aus:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
play 62
```

Nehmen wir einen anderen Klang - den *Prophet*:

```
use_synth :prophet
play 38
sleep 0.25
play 50
sleep 0.25
play 62
sleep 0.25
```

Wie wäre es damit, beide Sounds zu verbinden? Zuerst nacheinander:

```
use_synth :saw
play 38
sleep 0.25
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Jetzt machen wir mehrere Töne gleichzeitig, indem wir keine Pausen mit `sleep` zwischen Aufrufen von `play` einfügen:

```
use_synth :tb303
play 38
sleep 0.25
use_synth :dsaw
play 50
sleep 0.25
use_synth :prophet
play 57
sleep 0.25
```

Hast Du bemerkt, dass das `use_synth`-Kommando nur die nachfolgenden `play`-Kommandos beeinflusst? Stell Dir das als einen *großen Schalter* vor - neue Aufrufe von `play` werden immer den Synth benutzen, auf den der Schalter gerade zeigt. Du kannst diesen Schalter mit `use_synth` auf einen anderen Synth umschalten.


## Synths entdecken

Welche Synths Sonic Pi für Dich bereitstellt, kannst Du im Synths-Bereich auf der linken Seite des Hilfe-Fensters entdecken (gleich neben *Fx*). Es gibt über 20 Stück. Hier sind einige meiner Lieblings-Synths:

* `:prophet`
* `:dsaw`
* `:fm`
* `:tb303`
* `:pulse`

Spiel mal ein bisschen herum, indem Du *in Deinem Stück die Synths wechselst*. Kombiniere unterschiedliche Synths oder setze sie für unterschiedliche Stellen in Deinem Stück ein.
