2.2 Syntens tillval

# Syntens tillval: amp och pan

Förutom att låta dig bestämma vilken ton som skall spelas eller vilken sampling som skall startas, så ger dig Sonic Pi möjlighet att skruva på och kontrollera ljudet. Vi kommer täcka många av dessa i den här handledningen och det finns omfattande dokumentation för dem alla i hjälpsystemet. Men för nu kommer vi introducera två av de mest användbara: *amplitude* och *pan*. Först låt oss titta på vad opts egentligen är.


## Inställningar

Sonic Pis syntar stödjer ett antal parametrar (som vi kommer kalla Opts). Opts är kontroller du kan skicka till `play` som modifierar hur ljuden låter. Varje synth har sin egen uppsättning opts för att finjustera ljudet. Men det finns ett antal gemensamma opts som de flesta ljud kan använda sig av, till exempel `amp:` and envelope opts (kontur på svenska, förklaras i en annan sektion).

Opts have two major parts, their name (the name of the control) and their value (the value you want to set the control at). For example, you might have an opt called `cheese:` and want to set it with a value of `1`.

Opts skickas till anrop av `play`genom att använda ett komma `,` och sedan namnet på kontrollen, till exempel `amp:` (glöm inte kolon `:`) och sedan ett mellanslag och värdet du vill sätta kontrollen till:

```
play 50, cheese: 1
```

(Observera att `cheese:` inte är ett giltigt alternativ, vi använder det bara som ett exempel).

Du kan skicka flera alternativ genom att separera dem med komma:

```
play 50, cheese: 1, beans: 0.5
```

Alternativens ordning spelar ingen roll, så det följande är identiskt:

```
play 50, bönor: 0.5, ost: 1
```

Opts som inte känns igen av synthen ignoreras bara (som `cheese`och `beans` vilka helt klart är löjliga opt namn!)

Om du av misstag råkar använda samma opt två gånger med olika värden så vinner den sista. Till exempel `beans:`här kommer ha värdet 2 i stället för 0.5:

```
play 50, beans: 0.5, cheese: 3, eggs: 0.1, beans: 2
```

Många saker i Sonic Pi kan styras med opts, så vi föreslår att lägga ned lite tid på att lära dig hur du kan använda dem! Låt oss leka lite med vår första opt: `amp:`.

## Amplitud

Amplitud är en datorrepresentation av ljudstyrkan av ett ljud. En *hög amplitud ger ett högt ljud* och en *låg amplitud ger ett tyst ljud*. Precis som Sonic Pi använder siffror för att representera tid och noter så använder den siffror för att representera amplitud. En amplitud av 0 är tyst (du hör ingenting alls) och en amplitud av 1 är normal volym. Du kan till och med skruva upp amplituden högre till 2, 10, 100. Men om den totala volymen av alla ljud blir för hög så använder Sonic Pi något som kallas kompressor för att trycka ihop dem för att se till att det inte blir för högt för dina öron. Detta kan ofta göra att ljudet låter konstigt. Så försök använda låg amplitud, förslagsvis i området 0 till 0.5 för att undvika kompression.


## Skruva upp

För att ändra amplituden av ett ljud kan du använda `amp:`. Till exempel för att spela upp ljudet till halva amplituden, skicka 0.5 till funktionen:

```
play 60, amp: 0.5
```

För att spela upp med dubbel amplitud, skicka 2:

```
play 60, amp: 2
```

The `amp:` opt only modifies the call to `play` it's associated with. So, in this example, the first call to play is at half volume and the second is back to the default (1):

```
play 60, amp: 0.5
sleep 0.5
play 65
```

Of course, you can use different `amp:` values for each call to play:

```
play 50, amp: 0.1
sleep 0.25
play 55, amp: 0.2
sleep 0.25
play 57, amp: 0.4
sleep 0.25
play 62, amp: 1
```

## Panning

Another fun opt to use is `pan:` which controls the panning of a sound in stereo. Panning a sound to the left means that you hear it out of the left speaker, and panning it to the right means you hear it out of your right speaker. For our values, we use a -1 to represent fully left, 0 to represent center and 1 to represent fully right in the stereo field. Of course, we're free to use any value between -1 and 1 to control the exact positioning of our sound.

Let's play a beep out of the left speaker:

```
play 60, pan: -1
```

Now, let's play it out of the right speaker:

```
play 60, pan: 1
```

Finally let's play it back out of the center of both (the default position):

```
play 60, pan: 0
```

Now, go and have fun changing the amplitude and panning of your sounds!
